



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQL SERVER PIVOT与用法解释</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQL SERVER PIVOT与用法解释</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 22:32:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>通俗简单的说：PIVOT就是行转列，UNPIVOT就是列传行</p>
<p>在数据库操作中，有些时候我们遇到需要实现&ldquo;行转列&rdquo;的需求，例如一下的表为某店铺的一周收入情况表：</p>
<div>
<pre class="prettyprint linenums">WEEK_INCOME(WEEK VARCHAR(10),INCOME DECIMAL)</pre>
</div>
<p>我们先插入一些模拟数据：</p>
<div>
<pre class="prettyprint linenums">INSERT INTO WEEK_INCOME<br />
SELECT '星期一',1000UNION ALLSELECT '星期二',2000UNION ALLSELECT '星期三',3000UNION ALLSELECT '星期四',4000UNION ALLSELECT '星期五',5000UNION ALLSELECT '星期六',6000UNION ALLSELECT '星期日',7000</pre>
</div>
<p>一般我们最经常使用的查询是查询一周中每天或某几天的收入，例如查询周一至周日全部的收入：</p>
<div>
<pre class="prettyprint linenums">SELECT WEEK,INCOME FROM WEEK_INCOME</pre>
</div>
<p>得到如下的查询结果集：</p>
<p>WEEK &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; INCOME<br />星期一 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 1000<br />星期二 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2000<br />星期三 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 3000<br />星期四 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 4000<br />星期五 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5000<br />星期六 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 6000<br />星期日 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 7000</p>
<p>但是在一些情况下（往往是某些报表中），我们希望在一行中显示周一至周日的收入，这时候查询结果集应该是这样的：</p>
<p>星期一&nbsp;&nbsp;&nbsp;星期二&nbsp;&nbsp;&nbsp;星期三&nbsp;&nbsp;&nbsp;星期四&nbsp;&nbsp;&nbsp;星期五&nbsp;&nbsp;&nbsp;星期六&nbsp;&nbsp;&nbsp;星期日<br />1000 &nbsp; &nbsp; 2000 &nbsp; &nbsp; 3000 &nbsp; &nbsp; 4000 &nbsp; &nbsp; 5000 &nbsp; &nbsp; 6000 &nbsp; &nbsp; 7000</p>
<p>这种情况下，SQL查询语句可以这样写：</p>
<div>
<pre class="prettyprint linenums">SELECTSUM(CASE WEEK WHEN '星期一' THEN INCOME END) AS [星期一],<br />
SUM(CASE WEEK WHEN '星期二' THEN INCOME END) AS [星期二],<br />
SUM(CASE WEEK WHEN '星期三' THEN INCOME END) AS [星期三],<br />
SUM(CASE WEEK WHEN '星期四' THEN INCOME END) AS [星期四],<br />
SUM(CASE WEEK WHEN '星期五' THEN INCOME END) AS [星期五],<br />
SUM(CASE WEEK WHEN '星期六' THEN INCOME END) AS [星期六],<br />
SUM(CASE WEEK WHEN '星期日' THEN INCOME END) AS [星期日]FROM WEEK_INCOME</pre>
</div>
<p>但是，在SQL SERVER 2005中提供了更为简便的方法，这就是"PIVOT"关系运算符。（相反的&ldquo;列转行&rdquo;是UNPIVOT），以下是使用PIVOT实现&ldquo;行转列&rdquo;的SQL语句</p>
<div>
<pre class="prettyprint linenums">SELECT [星期一],[星期二],[星期三],[星期四],[星期五],[星期六],[星期日]FROM WEEK_INCOME<br />
PIVOT<br />
(<br />
    SUM(INCOME) for [week] in([星期一],[星期二],[星期三],[星期四],[星期五],[星期六],[星期日])<br />
)TBL</pre>
</div>
<p>请参考MSDN中关于PIVOT的用法：</p>
<p><a href="http://technet.microsoft.com/zh-cn/library/ms177410(v=sql.105).aspx" rel="external nofollow noreferrer">http://technet.microsoft.com/zh-cn/library/ms177410(v=sql.105).aspx</a></p>
<p>但是MSDN上的描述太过于规范严肃，我看了半天还没弄清楚怎样使用PIVOT，搞不清楚PIVOT里面的语法的含义。于是又google了很多资料，以及通过上面提到的WEEK_INCOME表例子作了试验，最终搞清楚了其用法。在网上有篇博文解释的很好：<a href="http://rely1020.blog.ithome.com.tw/post/1606/39111" rel="external nofollow noreferrer">T-SQL PIVOT語法剖析與實戰</a>，基本上我要写的就是参照该博文，再加上自己一点个人理解。</p>
<p>要理解PIVOT语法，就是要清楚微软为什么这样设计PIVOT，但我相信是现实需求催生设计思路，所以归根到底我们还是要弄清楚什么是&ldquo;行转列&rdquo;：</p>
<p>正常情况下的查询结果是这样：</p>
<p>星期一 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 1000<br />星期二 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2000<br />星期三 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 3000<br />星期四 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 4000<br />星期五 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5000<br />星期六 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 6000<br />星期日 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 7000</p>
<p>行转列后是这样：</p>
<p>星期一&nbsp;&nbsp;&nbsp;星期二&nbsp;&nbsp;&nbsp;星期三&nbsp;&nbsp;&nbsp;星期四&nbsp;&nbsp;&nbsp;星期五&nbsp;&nbsp;&nbsp;星期六&nbsp;&nbsp;&nbsp;星期日<br />1000&nbsp;&nbsp;&nbsp;&nbsp;2000&nbsp;&nbsp;&nbsp;&nbsp;3000&nbsp;&nbsp;&nbsp;&nbsp;4000&nbsp;&nbsp;&nbsp;&nbsp;5000&nbsp;&nbsp;&nbsp;&nbsp;6000&nbsp;&nbsp;&nbsp;&nbsp;7000</p>
<p>也就是说，行转列后，原来的某个列的值变做了列名，在这里就是原来WEEK列的值&ldquo;星期一&rdquo;,"星期二"..."星期日"边做了列名，而我们需要做的另一个工作就是计算这些列的值（这里的&ldquo;计算&rdquo;其实就是PIVOT里面的聚合函数(sum,avg等)）</p>
<p>现在结合注释来分析一下PIVOT语法(在这之前最好看看我上面提到博文：<a href="http://rely1020.blog.ithome.com.tw/post/1606/39111" rel="external nofollow noreferrer">T-SQL PIVOT語法剖析與實戰</a>，里面说到的PIVOT语法的三个步骤挺重要)：</p>
<div>
<pre class="prettyprint linenums">SELECT [星期一],[星期二],[星期三],[星期四],[星期五],[星期六],[星期日]--这里是PIVOT第三步（选择行转列后的结果集的列）这里可以用&ldquo;*&rdquo;表示选择所有列，也可以只选择某些列(也就是某些天)FROM WEEK_INCOME --这里是PIVOT第二步骤(准备原始的查询结果，因为PIVOT是对一个原始的查询结果集进行转换操作，所以先查询一个结果集出来)这里可以是一个select子查询，但为子查询时候要指定别名，否则语法错误PIVOT<br />
(<br />
    SUM(INCOME) for [week] in([星期一],[星期二],[星期三],[星期四],[星期五],[星期六],[星期日])--这里是PIVOT第一步骤，也是核心的地方，进行行转列操作。聚合函数SUM表示你需要怎样处理转换后的列的值，是总和(sum)，还是平均(avg)还是min,max等等。例如如果week_income表中有两条数据并且其week都是&ldquo;星期一&rdquo;，其中一条的income是1000,另一条income是500，那么在这里使用sum，行转列后&ldquo;星期一&rdquo;这个列的值当然是1500了。后面的for [week] in([星期一],[星期二]...)中 for [week]就是说将week列的值分别转换成一个个列，也就是&ldquo;以值变列&rdquo;。但是需要转换成列的值有可能有很多，我们只想取其中几个值转换成列，那么怎样取呢？就是在in里面了，比如我此刻只想看工作日的收入，在in里面就只写&ldquo;星期一&rdquo;至&ldquo;星期五&rdquo;（注意，in里面是原来week列的值,"以值变列"）。总的来说，SUM(INCOME) for [week] in([星期一],[星期二],[星期三],[星期四],[星期五],[星期六],[星期日])这句的意思如果直译出来，就是说：将列[week]值为"星期一","星期二","星期三","星期四","星期五","星期六","星期日"分别转换成列，这些列的值取income的总和。<br />
)TBL--别名一定要写</pre>
</div>
<p>以上是我对PIVOT的理解，我尽所能表达出来。不过话说回来，个人的理解的方式也不同，就如我开始看了很多篇博文，都没有搞清楚PIVOT用法。结果还是硬的通过例子和别人的博文再加上思考才弄懂了，所以如果各位看了本篇之后仍不能理解，那很正常，配合例子再加上自己思考，慢慢的定能理解。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j1reg9.html">ELF动态链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv35dy8.html">WPF入门教程系列四&mdash;&mdash;Dispatcher介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j02ynlq.html">ajax上传图片  jquery插件 jquery&period;form&period;js 的方法  ajaxSubmit&semi;  AjaxForm与AjaxSubmit的差异</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zn1j69.html">sql server 清除日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okr0jl9.html">Member var and Static var&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnm3ov8.html">animation的6个属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z1r469.html">BNU10805：矩形神码的</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd3xkr8.html">Autolayout-VFL语言添加约束－备</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljkrzk9.html">Spring学习（17）---  三种装配Bean方式比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1xo3jq.html">Java  this 关键字的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pnnpn8.html">JAVA对象及属性的内存堆栈管理（通过小程序简单说明）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950eorz8.html">【Android Studio安装部署系列】二十三、Android studio查看Gradle版本号</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mon1m8.html">mysql root password</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1emgxq.html">Mysql如何进行分组，并且让每一组的结果按照某个字段排序，并且获取每一组的第一个字段</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll5mo1q.html">题解-bzoj3569 DZY Loves Chinese II</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wvgrrq.html">【jvm】windows下查看java进程下多线程的相关信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllw6k0q.html">解决mysqli的中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eeym19.html">OpenMP并行编程应用&mdash;加速OpenCV图像拼接算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vnwp0q.html">Centos下cacti的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/90d73rn8.html">ZooKeeper原理    --------这可能是把ZooKeeper概念讲的最清楚的一篇文章</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8m22262q.html">自我理解node&period;js相比java的优势</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdddmd9.html">lucene之Field属性的解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j11m049.html">easyui的下拉框combox动态复赋值显示在前端</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rrpv28.html">使用jquery实现文本框输入特效：文字逐个显示逐个消失反复循环</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv22zex9.html">La nuova tecnologia del puntatore laser</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oonwj8.html">包建强的培训课程（4）：App测试深入学习和研究</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o115zxq.html">vue-router的history模式发布配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjj5369.html">【UOJ117】 欧拉回路（欧拉回路）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q255gdvq.html">Python学习笔记【第十三篇】：Python网络编程一Socket基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oo2ge8.html">SpringMVC框架五：图片上传与JSON交互</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
